(function($){
    $.fn.disableSelection = function() {
        return this
                 .attr('unselectable', 'on')
                 .css('user-select', 'none')
                 .on('selectstart', function(event){ var target = $( event.target ); return target.is("textarea") || target.is("input"); })
        		 .on('mousedown', function(event){ var target = $( event.target ); if(event.originalEvent.button == 2) return target.is("textarea") || target.is("input"); });
    };
    $.fn.enableSelection = function() {
        return this
        		 .attr('unselectable', 'off')
                 .css('user-select', 'all');
                 //.on('selectstart', function(){ return true; });
    };
})(jQuery);

$(function() {
	$('[data-action]').each(function() {
		$(this).prop('disabled', false);
		$(this).next().replaceWith($(this).next().text());
	});
	$('[data-action]').click(function() {
		var action = $(this).data('action');
		var params = $(this).data('action-params');
		if(!params)
			params = {};
		if($(this).attr('type') == 'checkbox')
		{
			params.value = $(this).prop('checked');
			fire(action, params);
		}
		else
		{
			return true;
		}
	});
	$('[data-action]').blur(function() {
		var action = $(this).data('action');
		var params = $(this).data('action-params');
		if(!params)
			params = {};
		if($(this).attr('type') == 'text')
		{
			params.value = $(this).val();
			fire(action, params);
		}
		else
		{
			return true;
		}
	});
	$('[data-action]').keyup(function(event) {
		if(event.keyCode == 13)
			$(this).blur();
	});
	
	$('html').disableSelection();
	$('#bug_details').scrollTop($('#bug_details').first().prop('scrollHeight'));
	$('textarea').enableSelection();
	
	$('html').css('cursor', 'default');
	
	$('a').focus(function() {$(this).blur();});
	
	$('img').on('dragstart', function(event) { event.preventDefault(); });
});

// disable right click and context menu for better look and feel

/*function disableclick(event)
{
  if(event.button==2)
     return false;    
}
document.onmousedown=disableclick;
*/